The following is a list of free and/or open source books on machine learning, statistics, data mining, etc.

## Machine Learning / Data Mining

* [The Hundred-Page Machine Learning Book](http://themlbook.com/wiki/doku.php)
* [Real World Machine Learning](https://www.manning.com/books/real-world-machine-learning) [Free Chapters]
* [An Introduction To Statistical Learning](https://www-bcf.usc.edu/~gareth/ISL/) - Book + R Code
* [Elements of Statistical Learning](https://web.stanford.edu/~hastie/ElemStatLearn/) - Book
* [Computer Age Statistical Inference (CASI)](https://web.stanford.edu/~hastie/CASI_files/PDF/casi.pdf) ([Permalink as of October 2017](https://perma.cc/J8JG-ZVFW)) - Book
* [Probabilistic Programming & Bayesian Methods for Hackers](http://camdavidsonpilon.github.io/Probabilistic-Programming-and-Bayesian-Methods-for-Hackers/) - Book + IPython Notebooks
* [Think Bayes](https://greenteapress.com/wp/think-bayes/) - Book + Python Code
* [Information Theory, Inference, and Learning Algorithms](http://www.inference.phy.cam.ac.uk/mackay/itila/book.html)
* [Gaussian Processes for Machine Learning](http://www.gaussianprocess.org/gpml/chapters/)
* [Data Intensive Text Processing w/ MapReduce](https://lintool.github.io/MapReduceAlgorithms/)
* [Reinforcement Learning: - An Introduction](http://incompleteideas.net/book/the-book-2nd.html) ([Permalink to Nov 2017 Draft](https://perma.cc/83ER-64M3))
* [Mining Massive Datasets](http://infolab.stanford.edu/~ullman/mmds/book.pdf)
* [A First Encounter with Machine Learning](https://www.ics.uci.edu/~welling/teaching/273ASpring10/IntroMLBook.pdf)
* [Pattern Recognition and Machine Learning](http://users.isr.ist.utl.pt/~wurmd/Livros/school/Bishop%20-%20Pattern%20Recognition%20And%20Machine%20Learning%20-%20Springer%20%202006.pdf)
* [Machine Learning & Bayesian Reasoning](http://web4.cs.ucl.ac.uk/staff/D.Barber/textbook/090310.pdf)
* [Introduction to Machine Learning](https://alex.smola.org/drafts/thebook.pdf) - Alex Smola and S.V.N. Vishwanathan
* [A Probabilistic Theory of Pattern Recognition](https://www.szit.bme.hu/~gyorfi/pbook.pdf)
* [Introduction to Information Retrieval](https://nlp.stanford.edu/IR-book/pdf/irbookprint.pdf)
* [Forecasting: principles and practice](https://otexts.com/fpp2/)
* [Practical Artificial Intelligence Programming in Java](https://www.saylor.org/site/wp-content/uploads/2011/11/CS405-1.1-WATSON.pdf)
* [Introduction to Machine Learning](https://arxiv.org/pdf/0904.3664v1.pdf) - Amnon Shashua
* [Reinforcement Learning](https://www.intechopen.com/books/reinforcement_learning)
* [Machine Learning](https://www.intechopen.com/books/machine_learning)
* [A Quest for AI](https://ai.stanford.edu/~nilsson/QAI/qai.pdf)
* [Introduction to Applied Bayesian Statistics and Estimation for Social Scientists](https://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.177.857&rep=rep1&type=pdf) - Scott M. Lynch
* [Bayesian Modeling, Inference and Prediction](https://users.soe.ucsc.edu/~draper/draper-BMIP-dec2005.pdf)
* [A Course in Machine Learning](http://ciml.info/)
* [Machine Learning, Neural and Statistical Classification](https://www1.maths.leeds.ac.uk/~charles/statlog/)
* [Bayesian Reasoning and Machine Learning](http://web4.cs.ucl.ac.uk/staff/D.Barber/pmwiki/pmwiki.php?n=Brml.HomePage) Book+MatlabToolBox
* [R Programming for Data Science](https://leanpub.com/rprogramming)
* [Data Mining - Practical Machine Learning Tools and Techniques](https://cdn.preterhuman.net/texts/science_and_technology/artificial_intelligence/Data%20Mining%20Practical%20Machine%20Learning%20Tools%20and%20Techniques%202d%20ed%20-%20Morgan%20Kaufmann.pdf) Book
* [Machine Learning with TensorFlow](https://www.manning.com/books/machine-learning-with-tensorflow) Early access book
* [Machine Learning Systems](https://www.manning.com/books/machine-learning-systems) Early access book
* [Hands‑On Machine Learning with Scikit‑Learn and TensorFlow](http://index-of.es/Varios-2/Hands%20on%20Machine%20Learning%20with%20Scikit%20Learn%20and%20Tensorflow.pdf) - Aurélien Géron
* [R for Data Science: Import, Tidy, Transform, Visualize, and Model Data](https://r4ds.had.co.nz/) - Wickham and Grolemund. Great as introduction on how to use R. 
* [Advanced R](http://adv-r.had.co.nz/) - Hadley Wickham. More advanced usage of R for programming.
* [Graph-Powered Machine Learning](https://www.manning.com/books/graph-powered-machine-learning) - Alessandro Negro. Combining graph theory and models to improve machine learning projects
* [Machine Learning for Dummies](https://mscdss.ds.unipi.gr/wp-content/uploads/2018/02/Untitled-attachment-00056-2-1.pdf)
* [Machine Learning for Mortals (Mere and Otherwise)](https://www.manning.com/books/machine-learning-for-mortals-mere-and-otherwise) - Early access book that provides basics of machine learning and using R programming language.
* [Grokking Machine Learning](https://www.manning.com/books/grokking-machine-learning) - Early access book that introduces the most valuable machine learning techniques.
- [Foundations of Machine Learning](https://cs.nyu.edu/~mohri/mlbook/) - Mehryar Mohri, Afshin Rostamizadeh, and Ameet Talwalkar
- [Understanding Machine Learning](http://www.cs.huji.ac.il/~shais/UnderstandingMachineLearning/) - Shai Shalev-Shwartz and Shai Ben-David
- [How Machine Learning Works](https://www.manning.com/books/how-machine-learning-works) - Mostafa Samir. Early access book that intorduces machine learning from both practical and theoretical aspects in a non-threating way. 

## Deep Learning

* [Deep Learning - An MIT Press book](https://www.deeplearningbook.org/)
* [Deep Learning with Python](https://www.manning.com/books/deep-learning-with-python)
* [Deep Learning with JavaScript](https://www.manning.com/books/deep-learning-with-javascript) Early access book
* [Grokking Deep Learning](https://www.manning.com/books/grokking-deep-learning) Early access book
* [Deep Learning for Search](https://www.manning.com/books/deep-learning-for-search) Early access book
* [Deep Learning and the Game of Go](https://www.manning.com/books/deep-learning-and-the-game-of-go) Early access book
* [Machine Learning for Business](https://www.manning.com/books/machine-learning-for-business) Early access book
* [Probabilistic Deep Learning with Python](https://www.manning.com/books/probabilistic-deep-learning-with-python) Early access book
* [Deep Learning with Structured Data](https://www.manning.com/books/deep-learning-with-structured-data) Early access book

## Natural Language Processing

* [Coursera Course Book on NLP](http://www.cs.columbia.edu/~mcollins/notes-spring2013.html)
* [NLTK](https://www.nltk.org/book/)
* [Foundations of Statistical Natural Language Processing](https://nlp.stanford.edu/fsnlp/promo/)
* [Natural Language Processing in Action](https://www.manning.com/books/natural-language-processing-in-action) Early access book
* [Real-World Natural Language Processing](https://www.manning.com/books/real-world-natural-language-processing) Early access book

## Information Retrieval

* [An Introduction to Information Retrieval](https://nlp.stanford.edu/IR-book/pdf/irbookonlinereading.pdf)

## Neural Networks

* [A Brief Introduction to Neural Networks](http://www.dkriesel.com/_media/science/neuronalenetze-en-zeta2-2col-dkrieselcom.pdf)
* [Neural Networks and Deep Learning](http://neuralnetworksanddeeplearning.com/)

## Probability & Statistics

* [Think Stats](https://www.greenteapress.com/thinkstats/) - Book + Python Code
* [From Algorithms to Z-Scores](http://heather.cs.ucdavis.edu/probstatbook) - Book
* [The Art of R Programming](http://heather.cs.ucdavis.edu/~matloff/132/NSPpart.pdf) - Book (Not Finished)
* [Introduction to statistical thought](https://people.math.umass.edu/~lavine/Book/book.pdf)
* [Basic Probability Theory](https://www.math.uiuc.edu/~r-ash/BPT/BPT.pdf)
* [Introduction to probability](https://math.dartmouth.edu/~prob/prob/prob.pdf) - By Dartmouth College
* [Probability & Statistics Cookbook](http://statistics.zone/)
* [Introduction to Probability](http://athenasc.com/probbook.html) -  Book and course by MIT
* [The Elements of Statistical Learning: Data Mining, Inference, and Prediction.](https://web.stanford.edu/~hastie/ElemStatLearn/) - Book
* [An Introduction to Statistical Learning with Applications in R](https://www-bcf.usc.edu/~gareth/ISL/) - Book
* [Introduction to Probability and Statistics Using R](http://ipsur.r-forge.r-project.org/book/download/IPSUR.pdf) - Book
* [Advanced R Programming](http://adv-r.had.co.nz) - Book
* [Practical Regression and Anova using R](https://cran.r-project.org/doc/contrib/Faraway-PRA.pdf) - Book
* [R practicals](http://www.columbia.edu/~cjd11/charles_dimaggio/DIRE/resources/R/practicalsBookNoAns.pdf) - Book
* [The R Inferno](https://www.burns-stat.com/pages/Tutor/R_inferno.pdf) - Book
* [Probability Theory: The Logic of Science](https://bayes.wustl.edu/etj/prob/book.pdf) - By Jaynes

## Linear Algebra

* [Linear Algebra and its applications by Gilbert strang](http://www.math.hcmus.edu.vn/~bxthang/Linear%20algebra%20and%20its%20applications.pdf)
* [The Matrix Cookbook](https://www.math.uwaterloo.ca/~hwolkowi/matrixcookbook.pdf)
* [Linear Algebra by Shilov](https://cosmathclub.files.wordpress.com/2014/10/georgi-shilov-linear-algebra4.pdf)
* [Linear Algebra Done Wrong](https://www.math.brown.edu/~treil/papers/LADW/LADW.html)
* [Linear Algebra, Theory, and Applications](https://math.byu.edu/~klkuttle/Linearalgebra.pdf)
* [Convex Optimization](https://web.stanford.edu/~boyd/cvxbook/bv_cvxbook.pdf)
* [Applied Numerical Computing](https://www.seas.ucla.edu/~vandenbe/ee133a.html)

## Calculus

* [Calculus Made Easy](https://github.com/lahorekid/Calculus/blob/master/Calculus%20Made%20Easy.pdf)
* [calculus by ron larson](https://www.spps.org/cms/lib/MN01910242/Centricity/Domain/860/%20CalculusTextbook.pdf)
